## mingw-w64-itk-5.4.0-2.src.tar.zst

=== Modules/IO/TransformMatlab/CMakeLists.txt ===
project(ITKIOTransformMatlab)
set(ITKIOTransformMatlab_LIBRARIES ITKIOTransformMatlab)
itk_module_impl()

=== Modules/ThirdParty/ZLIB/CMakeLists.txt ===
project(ITKZLIB)
set(ITKZLIB_THIRD_PARTY 1)

option(ITK_USE_SYSTEM_ZLIB "Use system-installed zlib" ${ITK_USE_SYSTEM_LIBRARIES})
mark_as_advanced(ITK_USE_SYSTEM_ZLIB)

if(ITK_USE_SYSTEM_ZLIB)
  find_package(ZLIB REQUIRED)
  set(ITKZLIB_INCLUDE_DIRS
    ${ITKZLIB_BINARY_DIR}/src
    )
  set(ITKZLIB_SYSTEM_INCLUDE_DIRS
    ${ZLIB_INCLUDE_DIRS}
    )
  set(ITKZLIB_LIBRARIES "${ZLIB_LIBRARIES}")
  set(ITKZLIB_NO_SRC 1)
else()
  set(ITKZLIB_INCLUDE_DIRS
    ${ITKZLIB_BINARY_DIR}/src
    ${ITKZLIB_BINARY_DIR}/src/itkzlib-ng
    ${ITKZLIB_SOURCE_DIR}/src
    )
  set(ITKZLIB_LIBRARIES zlib)
endif()

configure_file(src/itk_zlib.h.in src/itk_zlib.h)
set(ITK_LIBRARY_PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS FALSE)
itk_module_impl()

install(FILES ${ITKZLIB_BINARY_DIR}/src/itk_zlib.h
  DESTINATION ${ITKZLIB_INSTALL_INCLUDE_DIR}
  COMPONENT Development
  )

=== Modules/Filtering/GPUSmoothing/wrapping/CMakeLists.txt ===
if(ITK_USE_GPU OR NOT ITK_SOURCE_DIR)
  itk_wrap_module(ITKGPUSmoothing)
  itk_auto_load_and_end_wrap_submodules()
endif()

=== Modules/Filtering/LabelMap/test/CMakeLists.txt ===
itk_module_test()
set(ITKLabelMapTests
    itkAggregateLabelMapFilterTest.cxx
    itkAttributeKeepNObjectsLabelMapFilterTest1.cxx
    itkAttributeLabelObjectAccessorsTest1.cxx
    itkAttributeOpeningLabelMapFilterTest1.cxx
    itkAttributePositionLabelMapFilterTest1.cxx
    itkAttributeRelabelLabelMapFilterTest1.cxx
    itkAttributeUniqueLabelMapFilterTest1.cxx
    itkAutoCropLabelMapFilterTest1.cxx
    itkAutoCropLabelMapFilterTest2.cxx
    itkBinaryFillholeImageFilterTest1.cxx
    itkBinaryGrindPeakImageFilterTest1.cxx
    itkBinaryImageToLabelMapFilterTest.cxx
    itkBinaryImageToLabelMapFilterTest2.cxx
    itkBinaryImageToShapeLabelMapFilterTest1.cxx
    itkBinaryImageToStatisticsLabelMapFilterTest1.cxx
    itkBinaryNotImageFilterTest.cxx
    itkBinaryReconstructionByDilationImageFilterTest.cxx
    itkBinaryReconstructionByErosionImageFilterTest.cxx
    itkBinaryReconstructionLabelMapFilterTest.cxx
    itkBinaryShapeKeepNObjectsImageFilterTest1.cxx
    itkBinaryShapeOpeningImageFilterTest1.cxx
    itkBinaryStatisticsKeepNObjectsImageFilterTest1.cxx
    itkBinaryStatisticsOpeningImageFilterTest1.cxx
    itkChangeLabelLabelMapFilterTest.cxx
    itkChangeRegionLabelMapFilterTest1.cxx
    itkConvertLabelMapFilterTest1.cxx
    itkConvertLabelMapFilterTest2.cxx
    itkCropLabelMapFilterTest1.cxx
    itkLabelImageToLabelMapFilterTest.cxx
    itkLabelImageToShapeLabelMapFilterTest1.cxx
    itkLabelImageToStatisticsLabelMapFilterTest1.cxx
    itkLabelMapFilterTest.cxx
    itkLabelMapMaskImageFilterTest.cxx
    itkLabelMapTest.cxx
    itkLabelMapTest2.cxx
    itkLabelMapToAttributeImageFilterTest1.cxx
    itkLabelMapToBinaryImageFilterTest.cxx
    itkLabelMapToLabelImageFilterTest.cxx
    itkLabelObjectLineComparatorTest.cxx
    itkLabelObjectLineTest.cxx
    itkLabelObjectTest.cxx
    itkLabelSelectionLabelMapFilterTest.cxx
    itkLabelShapeKeepNObjectsImageFilterTest1.cxx
    itkLabelShapeOpeningImageFilterTest1.cxx
    itkLabelStatisticsKeepNObjectsImageFilterTest1.cxx
    itkLabelStatisticsOpeningImageFilterTest1.cxx
    itkLabelUniqueLabelMapFilterTest1.cxx
    itkMergeLabelMapFilterTest1.cxx
    itkObjectByObjectLabelMapFilterTest.cxx
    itkPadLabelMapFilterTest1.cxx
    itkRegionFromReferenceLabelMapFilterTest1.cxx
    itkRelabelLabelMapFilterTest1.cxx
    itkShapeKeepNObjectsLabelMapFilterTest1.cxx
    itkShapeLabelObjectAccessorsTest1.cxx
    itkShapeOpeningLabelMapFilterTest1.cxx
    itkShapePositionLabelMapFilterTest1.cxx
    itkShapeRelabelImageFilterTest1.cxx
    itkShapeRelabelLabelMapFilterTest1.cxx
    itkShapeUniqueLabelMapFilterTest1.cxx
    itkShiftLabelObjectTest.cxx
    itkShiftScaleLabelMapFilterTest1.cxx
    itkStatisticsKeepNObjectsLabelMapFilterTest1.cxx
    itkStatisticsOpeningLabelMapFilterTest1.cxx
    itkStatisticsPositionLabelMapFilterTest1.cxx
    itkStatisticsRelabelImageFilterTest1.cxx
    itkStatisticsRelabelLabelMapFilterTest1.cxx
    itkStatisticsUniqueLabelMapFilterTest1.cxx)

createtestdriver(ITKLabelMap "${ITKLabelMap-Test_LIBRARIES}" "${ITKLabelMapTests}")

itk_add_test(
  NAME
  itkShiftLabelObjectTest
  COMMAND
  ITKLabelMapTestDriver
  itkShiftLabelObjectTest)
itk_add_test(
  NAME
  itkAggregateLabelMapFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/cthead1-labelAggregate.mha}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-labelAggregate.mha
  itkAggregateLabelMapFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-labelAggregate.mha)
itk_add_test(
  NAME
  itkAttributeKeepNObjectsLabelMapFilterTest0
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkAttributeKeepNObjectsLabelMapFilterTest0.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeKeepNObjectsLabelMapFilterTest0.png
  itkAttributeKeepNObjectsLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeKeepNObjectsLabelMapFilterTest0.png
  2
  0)
itk_add_test(
  NAME
  itkAttributeKeepNObjectsLabelMapFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkAttributeKeepNObjectsLabelMapFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeKeepNObjectsLabelMapFilterTest1.png
  itkAttributeKeepNObjectsLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeKeepNObjectsLabelMapFilterTest1.png
  2
  1)
itk_add_test(
  NAME
  itkAttributeLabelObjectAccessorsTest1
  COMMAND
  ITKLabelMapTestDriver
  itkAttributeLabelObjectAccessorsTest1
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png})
itk_add_test(
  NAME
  itkAttributeOpeningLabelMapFilterTest0
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkAttributeOpeningLabelMapFilterTest0.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeOpeningLabelMapFilterTest0.png
  itkAttributeOpeningLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeOpeningLabelMapFilterTest0.png
  2
  0)
itk_add_test(
  NAME
  itkAttributeOpeningLabelMapFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkAttributeOpeningLabelMapFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeOpeningLabelMapFilterTest1.png
  itkAttributeOpeningLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeOpeningLabelMapFilterTest1.png
  2
  1)
itk_add_test(
  NAME
  itkAttributePositionLabelMapFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkAttributePositionLabelMapFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributePositionLabelMapFilterTest1.png
  itkAttributePositionLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributePositionLabelMapFilterTest1.png)
itk_add_test(
  NAME
  itkAttributeRelabelLabelMapFilterTest0
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkAttributeRelabelLabelMapFilterTest0.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeRelabelLabelMapFilterTest0.png
  itkAttributeRelabelLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeRelabelLabelMapFilterTest0.png
  0)
itk_add_test(
  NAME
  itkAttributeRelabelLabelMapFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkAttributeRelabelLabelMapFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeRelabelLabelMapFilterTest1.png
  itkAttributeRelabelLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeRelabelLabelMapFilterTest1.png
  1)
itk_add_test(
  NAME
  itkAttributeUniqueLabelMapFilterTest0
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkAttributeUniqueLabelMapFilterTest0.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeUniqueLabelMapFilterTest0.png
  itkAttributeUniqueLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeUniqueLabelMapFilterTest0.png
  0)
itk_add_test(
  NAME
  itkAttributeUniqueLabelMapFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkAttributeUniqueLabelMapFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeUniqueLabelMapFilterTest1.png
  itkAttributeUniqueLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/SpotsLabeled.png}
  ${ITK_TEST_OUTPUT_DIR}/itkAttributeUniqueLabelMapFilterTest1.png
  1)
itk_add_test(
  NAME
  itkAutoCropLabelMapFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/cthead1-label-autocrop.mha}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-label-autocrop.mha
  itkAutoCropLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/cthead1Label.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-label-autocrop.mha
  176
  4
  4)
itk_add_test(
  NAME
  itkBinaryFillholeImageFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkBinaryFillholeImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryFillholeImageFilterTest1.png
  itkBinaryFillholeImageFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/Spots.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryFillholeImageFilterTest1.png
  1
  255)
itk_add_test(
  NAME
  itkBinaryFillholeImageFilterTest3D_0
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/fillhole_test_3D_0.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryFillholeImageFilterTest3D_0.nrrd
  itkBinaryFillholeImageFilterTest1
  DATA{Input/fillhole_test_3D.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryFillholeImageFilterTest3D_0.nrrd
  0
  1)
itk_add_test(
  NAME
  itkBinaryFillholeImageFilterTest3D_1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/fillhole_test_3D_1.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryFillholeImageFilterTest3D_1.nrrd
  itkBinaryFillholeImageFilterTest1
  DATA{Input/fillhole_test_3D.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryFillholeImageFilterTest3D_1.nrrd
  1
  1)
itk_add_test(
  NAME
  itkBinaryGrindPeakImageFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkBinaryGrindPeakImageFilterTest1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryGrindPeakImageFilterTest1.png
  itkBinaryGrindPeakImageFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/SpotsInverted.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryGrindPeakImageFilterTest1.png
  1
  255
  0)
itk_add_test(
  NAME
  itkBinaryGrindPeakImageFilterTest2
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/itkBinaryGrindPeakImageFilterTest2.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryGrindPeakImageFilterTest2.png
  itkBinaryGrindPeakImageFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/SpotsInverted.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBinaryGrindPeakImageFilterTest2.png
  0
  255
  0)
itk_add_test(
  NAME
  itkBinaryImageToLabelMapFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/cthead1-labeled.mha}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-labeled.mha
  itkBinaryImageToLabelMapFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1-mask.png}
  ${ITK_TEST_OUTPUT_DIR}/cthead1-labeled.mha
  1
  255
  0
  0)
itk_add_test(
  NAME
  itkBinaryImageToLabelMapFilterTest2
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/connected0lines-0.png}
  ${ITK_TEST_OUTPUT_DIR}/connected0lines-0.png
  itkBinaryImageToLabelMapFilterTest
  DATA{${ITK_DATA_ROOT}/Input/connected0lines.png}
  ${ITK_TEST_OUTPUT_DIR}/connected0lines-0.png
  0
  255
  0
  0)
itk_add_test(
  NAME
  itkBinaryImageToLabelMapFilterTest3
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/connected0lines-1.png}
  ${ITK_TEST_OUTPUT_DIR}/connected0lines-1.png
  itkBinaryImageToLabelMapFilterTest
  DATA{${ITK_DATA_ROOT}/Input/connected0lines.png}
  ${ITK_TEST_OUTPUT_DIR}/connected0lines-1.png
  1
  255
  0
  0)
itk_add_test(
  NAME
  itkBinaryImageToLabelMapFilterTest4
  COMMAND
  ITKLabelMapTestDriver
  itkBinaryImageToLabelMapFilterTest
  DATA{${ITK_DATA_ROOT}/Input/289.png}
  ${ITK_TEST_OUTPUT_DIR}/tooManyObjects.png
  0
  255
  0
  1)
itk_add_test(
  NAME
  itkBinaryImageToLabelMapFilterTest5
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/nonConnected3DLines-0.tif}
  ${ITK_TEST_OUTPUT_DIR}/nonConnected3DLines-0.tif
  itkBinaryImageToLabelMapFilterTest
  DATA{${ITK_DATA_ROOT}/Input/nonConnected3DLines.tif}
  ${ITK_TEST_OUTPUT_DIR}/nonConnected3DLines-0.tif
  0
  255
  0
  0)
itk_add_test(
  NAME
  itkBinaryImageToLabelMapFilterTest6
  COMMAND
  ITKLabelMapTestDriver
  itkBinaryImageToLabelMapFilterTest2
  DATA{${ITK_DATA_ROOT}/Input/BinaryImage1Row.bmp}
  ${ITK_TEST_OUTPUT_DIR}/LabelImage1Row.bmp
  255
  0
  2)
itk_add_test(
  NAME
  itkBinaryImageToLabelMapFilterTest7
  COMMAND
  ITKLabelMapTestDriver
  itkBinaryImageToLabelMapFilterTest2
  DATA{${ITK_DATA_ROOT}/Input/BinaryImage1Row.bmp}
  ${ITK_TEST_OUTPUT_DIR}/LabelImage1Row.bmp
  255
  0
  1)
itk_add_test(
  NAME
  itkBinaryImageToShapeLabelMapFilterTest1
  COMMAND
  ITKLabelMapTestDriver
  --compare
  DATA{Baseline/Spots-binaryimage-to-shapelabel.mha}
  ${ITK_TEST_OUTPUT_DIR}/Spots-binaryimage-to-shapelabel.mha
  itkBinaryImageToShapeLabelMapFilterTest1
  DATA{${ITK_DATA_ROOT}/Input/Spots.png}

=== Modules/Filtering/Thresholding/test/CMakeLists.txt ===
itk_module_test()
set(ITKThresholdingTests
    itkBinaryThresholdImageFilterTest2.cxx
    itkBinaryThresholdImageFilterTest.cxx
    itkBinaryThresholdProjectionImageFilterTest.cxx
    itkBinaryThresholdSpatialFunctionTest.cxx
    itkHuangThresholdImageFilterTest.cxx
    itkIntermodesThresholdImageFilterTest.cxx
    itkIsoDataThresholdImageFilterTest.cxx
    itkKittlerIllingworthThresholdImageFilterTest.cxx
    itkLiThresholdImageFilterTest.cxx
    itkMaximumEntropyThresholdImageFilterTest.cxx
    itkMomentsThresholdImageFilterTest.cxx
    itkOtsuMultipleThresholdsCalculatorTest.cxx
    itkOtsuMultipleThresholdsCalculatorTest2.cxx
    itkOtsuMultipleThresholdsImageFilterTest.cxx
    #itkOtsuThresholdCalculatorVersusOtsuMultipleThresholdsCalculatorTest.cxx
    itkOtsuThresholdCalculatorTest.cxx
    itkOtsuThresholdImageFilterTest.cxx
    itkRenyiEntropyThresholdImageFilterTest.cxx
    itkShanbhagThresholdImageFilterTest.cxx
    itkThresholdImageFilterTest.cxx
    itkThresholdLabelerImageFilterTest.cxx
    itkTriangleThresholdImageFilterTest.cxx
    itkYenThresholdImageFilterTest.cxx
    itkHuangMaskedThresholdImageFilterTest.cxx
    itkIntermodesMaskedThresholdImageFilterTest.cxx
    itkIsoDataMaskedThresholdImageFilterTest.cxx
    itkKittlerIllingworthMaskedThresholdImageFilterTest.cxx
    itkLiMaskedThresholdImageFilterTest.cxx
    itkMaximumEntropyMaskedThresholdImageFilterTest.cxx
    itkMomentsMaskedThresholdImageFilterTest.cxx
    itkOtsuMaskedThresholdImageFilterTest.cxx
    itkRenyiEntropyMaskedThresholdImageFilterTest.cxx
    itkShanbhagMaskedThresholdImageFilterTest.cxx
    itkTriangleMaskedThresholdImageFilterTest.cxx
    itkYenMaskedThresholdImageFilterTest.cxx
    itkKappaSigmaThresholdImageCalculatorTest.cxx
    itkKappaSigmaThresholdImageFilterTest.cxx)

createtestdriver(ITKThresholding "${ITKThresholding-Test_LIBRARIES}" "${ITKThresholdingTests}")

itk_add_test(
  NAME
  itkOtsuThresholdCalculatorTest
  COMMAND
  ITKThresholdingTestDriver
  itkOtsuThresholdCalculatorTest)

itk_add_test(
  NAME
  itkOtsuMultipleThresholdsImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkOtsuMultipleThresholdsImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkOtsuMultipleThresholdsImageFilterTest.png
  itkOtsuMultipleThresholdsImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/peppers.png}
  ${ITK_TEST_OUTPUT_DIR}/itkOtsuMultipleThresholdsImageFilterTest.png
  64
  3
  2
  0
  1)

itk_add_test(
  NAME
  itkThresholdLabelerImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  itkThresholdLabelerImageFilterTest)
itk_add_test(
  NAME
  itkBinaryThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  itkBinaryThresholdImageFilterTest)
itk_add_test(
  NAME
  itkThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  itkThresholdImageFilterTest)
itk_add_test(
  NAME
  itkOtsuMultipleThresholdsCalculatorTest1
  COMMAND
  ITKThresholdingTestDriver
  itkOtsuMultipleThresholdsCalculatorTest
  0
  0)
itk_add_test(
  NAME
  itkOtsuMultipleThresholdsCalculatorTest2
  COMMAND
  ITKThresholdingTestDriver
  itkOtsuMultipleThresholdsCalculatorTest
  1
  0)
itk_add_test(
  NAME
  itkBinaryThresholdImageFilterTest2
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/BasicFilters/BinaryThresholdImageFilterTest2.png}
  ${ITK_TEST_OUTPUT_DIR}/BinaryThresholdImageFilterTest2.png
  itkBinaryThresholdImageFilterTest2
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/DicomSeries/Image0076.dcm}
  ${ITK_TEST_OUTPUT_DIR}/BinaryThresholdImageFilterTest2.png)
itk_add_test(
  NAME
  itkBinaryThresholdProjectionImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/BasicFilters/HeadMRVolumeBinaryThresholdProjection.png}
  ${ITK_TEST_OUTPUT_DIR}/HeadMRVolumeBinaryThresholdProjection.png
  itkBinaryThresholdProjectionImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/HeadMRVolumeBinaryThresholdProjection.png
  100
  255
  0)
itk_add_test(
  NAME
  itkBinaryThresholdSpatialFunctionTest
  COMMAND
  ITKThresholdingTestDriver
  itkBinaryThresholdSpatialFunctionTest)

itk_add_test(
  NAME
  itkHuangThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkHuangThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkHuangThresholdImageFilterTest.png
  itkHuangThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkHuangThresholdImageFilterTest.png
  256
  1
  19)
itk_add_test(
  NAME
  itkHuangThresholdImageFilterTestNoAutoMinMax
  COMMAND
  ITKThresholdingTestDriver
  --compare-MD5
  DATA{Baseline/itkHuangThresholdImageFilterTestNoAutoMinMax.png}
  fdcefb74090f63114d811e92f0f5836b
  itkHuangThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkHuangThresholdImageFilterTestNoAutoMinMax.png
  32
  0
  -31744)

itk_add_test(
  NAME
  itkHuangMaskedThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkHuangMaskedThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkHuangMaskedThresholdImageFilterTest.png
  itkHuangMaskedThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1-threshmask.png}
  ${ITK_TEST_OUTPUT_DIR}/itkHuangMaskedThresholdImageFilterTest.png
  1
  255
  239)

itk_add_test(
  NAME
  itkIntermodesThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkIntermodesThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIntermodesThresholdImageFilterTest.png
  itkIntermodesThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIntermodesThresholdImageFilterTest.png
  256
  1
  1000
  1
  76)
itk_add_test(
  NAME
  itkIntermodesThresholdImageFilterTestNoInterMode
  COMMAND
  ITKThresholdingTestDriver
  --compare-MD5
  DATA{Baseline/itkIntermodesThresholdImageFilterTestNoInterMode.png}
  eed45f177050894e50ec1be5bc6bd4fa
  itkIntermodesThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIntermodesThresholdImageFilterTestNoInterMode.png
  32
  1
  2000
  0
  75)
#itk_add_test(NAME itkIntermodesThresholdImageFilterTestNoAutoMinMax
#      COMMAND ITKThresholdingTestDriver
#    --compare-MD5 DATA{Baseline/itkIntermodesThresholdImageFilterTestNoAutoMinMax.png}
#              eed45f177050894e50ec1be5bc6bd4fa
#    itkIntermodesThresholdImageFilterTest DATA{${ITK_DATA_ROOT}/Input/cthead1.png} ${ITK_TEST_OUTPUT_DIR}/itkIntermodesThresholdImageFilterTestNoAutoMinMax.png 32 0 400000 0 19)

itk_add_test(
  NAME
  itkIntermodesMaskedThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkIntermodesMaskedThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIntermodesMaskedThresholdImageFilterTest.png
  itkIntermodesMaskedThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1-threshmask.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIntermodesMaskedThresholdImageFilterTest.png
  1
  255
  1000
  1
  97)

itk_add_test(
  NAME
  itkIsoDataThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkIsoDataThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIsoDataThresholdImageFilterTest.png
  itkIsoDataThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIsoDataThresholdImageFilterTest.png
  256
  1
  85)
itk_add_test(
  NAME
  itkIsoDataThresholdImageFilterTestNoAutoMinMax
  COMMAND
  ITKThresholdingTestDriver
  --compare-MD5
  DATA{Baseline/itkIsoDataThresholdImageFilterTestNoAutoMinMax.png}
  9f844fd120ff49a7812e329a1b0216d8
  itkIsoDataThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIsoDataThresholdImageFilterTestNoAutoMinMax.png
  32
  0
  1023)

itk_add_test(
  NAME
  itkIsoDataMaskedThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkIsoDataMaskedThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIsoDataMaskedThresholdImageFilterTest.png
  itkIsoDataMaskedThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1-threshmask.png}
  ${ITK_TEST_OUTPUT_DIR}/itkIsoDataMaskedThresholdImageFilterTest.png
  1
  255
  114)

itk_add_test(
  NAME
  itkKittlerIllingworthThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkKittlerIllingworthThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkKittlerIllingworthThresholdImageFilterTest.png
  itkKittlerIllingworthThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkKittlerIllingworthThresholdImageFilterTest.png
  256
  1
  32)
itk_add_test(
  NAME
  itkKittlerIllingworthThresholdImageFilterTestNoAutoMinMax
  COMMAND
  ITKThresholdingTestDriver
  --compare-MD5
  DATA{Baseline/itkKittlerIllingworthThresholdImageFilterTestNoAutoMinMax.png}
  ecb99e6ffea7be1e5419350f725da86b
  itkKittlerIllingworthThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkKittlerIllingworthThresholdImageFilterTestNoAutoMinMax.png
  32
  0
  1023)

itk_add_test(
  NAME
  itkKittlerIllingworthMaskedThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkKittlerIllingworthMaskedThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkKittlerIllingworthMaskedThresholdImageFilterTest.png
  itkKittlerIllingworthMaskedThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1-threshmask.png}
  ${ITK_TEST_OUTPUT_DIR}/itkKittlerIllingworthMaskedThresholdImageFilterTest.png
  1
  255
  254)

itk_add_test(
  NAME
  itkLiThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkLiThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLiThresholdImageFilterTest.png
  itkLiThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLiThresholdImageFilterTest.png
  256
  1
  54)
itk_add_test(
  NAME
  itkLiThresholdImageFilterTestNoAutoMinMax
  COMMAND
  ITKThresholdingTestDriver
  --compare-MD5
  DATA{Baseline/itkLiThresholdImageFilterTestNoAutoMinMax.png}
  ecb99e6ffea7be1e5419350f725da86b
  itkLiThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLiThresholdImageFilterTestNoAutoMinMax.png
  32
  0
  1023)

itk_add_test(
  NAME
  itkLiMaskedThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkLiMaskedThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLiMaskedThresholdImageFilterTest.png
  itkLiMaskedThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  DATA{${ITK_DATA_ROOT}/Input/cthead1-threshmask.png}
  ${ITK_TEST_OUTPUT_DIR}/itkLiMaskedThresholdImageFilterTest.png
  1
  255
  177)

itk_add_test(
  NAME
  itkMaximumEntropyThresholdImageFilterTest
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkMaximumEntropyThresholdImageFilterTest.png}
  ${ITK_TEST_OUTPUT_DIR}/itkMaximumEntropyThresholdImageFilterTest.png
  itkMaximumEntropyThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkMaximumEntropyThresholdImageFilterTest.png
  256
  1
  140)
itk_add_test(
  NAME
  itkMaximumEntropyThresholdImageFilterTestNoAutoMinMax
  COMMAND
  ITKThresholdingTestDriver
  --compare
  DATA{Baseline/itkMaximumEntropyThresholdImageFilterTestNoAutoMinMax.png}
  ${ITK_TEST_OUTPUT_DIR}/itkMaximumEntropyThresholdImageFilterTestNoAutoMinMax.png
  itkMaximumEntropyThresholdImageFilterTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkMaximumEntropyThresholdImageFilterTestNoAutoMinMax.png
  32
  0
  -31744)

itk_add_test(
  NAME

=== Modules/IO/ImageBase/test/CMakeLists.txt ===
itk_module_test()
set(ITKIOImageBaseTests
    itkConvertBufferTest.cxx
    itkConvertBufferTest2.cxx
    itkImageFileReaderTest1.cxx
    itkImageFileWriterTest.cxx
    itkIOCommonTest.cxx
    itkIOCommonTest2.cxx
    itkNumericSeriesFileNamesTest.cxx
    itkRegularExpressionSeriesFileNamesTest.cxx
    itkArchetypeSeriesFileNamesTest.cxx
    itkLargeImageWriteConvertReadTest.cxx
    itkLargeImageWriteReadTest.cxx
    itkImageFileReaderDimensionsTest.cxx
    itkImageFileReaderPositiveSpacingTest.cxx
    itkImageFileReaderStreamingTest.cxx
    itkImageFileReaderStreamingTest2.cxx
    itkImageFileWriterPastingTest1.cxx
    itkImageFileWriterPastingTest2.cxx
    itkImageFileWriterPastingTest3.cxx
    itkImageFileWriterStreamingPastingCompressingTest1.cxx
    itkImageFileWriterStreamingTest1.cxx
    itkImageFileWriterStreamingTest2.cxx
    itkImageFileWriterTest2.cxx
    itkImageFileWriterUpdateLargestPossibleRegionTest.cxx
    itkImageIOBaseTest.cxx
    itkImageIODirection2DTest.cxx
    itkImageIODirection3DTest.cxx
    itkImageIOFileNameExtensionsTests.cxx
    itkImageSeriesReaderDimensionsTest.cxx
    itkImageSeriesReaderSamplingTest.cxx
    itkImageSeriesReaderVectorTest.cxx
    itkImageSeriesWriterTest.cxx
    itkIOPluginTest.cxx
    itkNoiseImageFilterTest.cxx
    itkMatrixImageWriteReadTest.cxx
    itkReadWriteImageWithDictionaryTest.cxx
    itkVectorImageReadWriteTest.cxx
    itk64bitTest.cxx
    itkImageFileReaderManyComponentVectorTest.cxx)

createtestdriver(ITKIOImageBase "${ITKIOImageBase-Test_LIBRARIES}" "${ITKIOImageBaseTests}")
itk_add_test(
  NAME
  itkArchetypeSeriesFileNamesTest
  COMMAND
  ITKIOImageBaseTestDriver
  itkArchetypeSeriesFileNamesTest
  DATA{${ITK_DATA_ROOT}/Input/Archetype/a5b7.PNG,REGEX:a[0-9]b[0-9]\\.PNG}
  DATA{${ITK_DATA_ROOT}/Input/Archetype/a7b1.PNG})
itk_add_test(
  NAME
  itkArchetypeSeriesFileNamesTest2
  COMMAND
  ITKIOImageBaseTestDriver
  itkArchetypeSeriesFileNamesTest
  DATA{${ITK_DATA_ROOT}/Input/Archetype/image.001,REGEX:image\\.[0-9]+}
  DATA{${ITK_DATA_ROOT}/Input/Archetype/image.010})
itk_add_test(
  NAME
  itkConvertBufferTest
  COMMAND
  ITKIOImageBaseTestDriver
  itkConvertBufferTest)
itk_add_test(
  NAME
  itkConvertBufferTest2
  COMMAND
  ITKIOImageBaseTestDriver
  itkConvertBufferTest2)
itk_add_test(
  NAME
  itkImageFileReaderTest1
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileReaderTest1)
itk_add_test(
  NAME
  itkImageFileWriterTest
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterTest
  ${ITK_TEST_OUTPUT_DIR}/test.png)
itk_add_test(
  NAME
  itkIOCommonTest
  COMMAND
  ITKIOImageBaseTestDriver
  itkIOCommonTest)
itk_add_test(
  NAME
  itkIOCommonTest2
  COMMAND
  ITKIOImageBaseTestDriver
  itkIOCommonTest2)
itk_add_test(
  NAME
  itkNumericSeriesFileNamesTest
  COMMAND
  ITKIOImageBaseTestDriver
  itkNumericSeriesFileNamesTest)
itk_add_test(
  NAME
  itk64bitTestNRRDtoMHA
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{Input/Test64bit.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit.mha
  itk64bitTest
  DATA{Input/Test64bit.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit.mha)
itk_add_test(
  NAME
  itk64bitTestMHAtoNRRD
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{Input/Test64bit.mha}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit.nrrd
  itk64bitTest
  DATA{Input/Test64bit.mha}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit.nrrd)
itk_add_test(
  NAME
  itk64bitTestNRRDtoMHA2
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{Input/Test64bit.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit2.mha
  itk64bitTest
  DATA{Input/Test64bit.mha}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit2.mha)
itk_add_test(
  NAME
  itk64bitTestNRRDtoNIFTI
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{Input/Test64bit.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit.nii
  itk64bitTest
  DATA{Input/Test64bit.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit.nii)
itk_add_test(
  NAME
  itk64bitTestNRRDtoVTK
  COMMAND
  ITKIOImageBaseTestDriver
  --ignoreInputInformation
  --compare
  DATA{Input/Test64bit.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit.vtk
  itk64bitTest
  DATA{Input/Test64bit.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/Test64bit.vtk)

itk_add_test(
  NAME
  itkRegularExpressionSeriesFileNamesTest
  COMMAND
  ITKIOImageBaseTestDriver
  --redirectOutput
  ${ITK_TEST_OUTPUT_DIR}/itkRegularExpressionSeriesFileNamesTest.txt
  itkRegularExpressionSeriesFileNamesTest
  ${ITK_DATA_ROOT}/Input)
set_tests_properties(
  itkRegularExpressionSeriesFileNamesTest PROPERTIES ATTACHED_FILES_ON_FAIL
                                                     ${ITK_TEST_OUTPUT_DIR}/itkRegularExpressionSeriesFileNamesTest.txt)

itk_add_test(
  NAME
  itkImageFileReaderDimensionsTest_MHD
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileReaderDimensionsTest
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha}
  ${ITK_TEST_OUTPUT_DIR}
  mha)
itk_add_test(
  NAME
  itkImageFileReaderDimensionsTest_NRRD
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileReaderDimensionsTest
  DATA{${ITK_DATA_ROOT}/Input/vol-ascii.nrrd}
  ${ITK_TEST_OUTPUT_DIR}
  nrrd)
itk_add_test(
  NAME
  itkImageFileReaderStreamingTest_1
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileReaderStreamingTest
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  1
  0)
itk_add_test(
  NAME
  itkImageFileReaderStreamingTest_2
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileReaderStreamingTest
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  0
  1)
itk_add_test(
  NAME
  itkImageFileReaderStreamingTest_3
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileReaderStreamingTest
  DATA{${ITK_DATA_ROOT}/Input/vol-ascii.nrrd}
  0
  0)
itk_add_test(
  NAME
  itkImageFileReaderStreamingTest2_MHD
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileReaderStreamingTest2
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw})
itk_add_test(
  NAME
  itkImageFileWriterPastingTest1
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterPastingTest1_01.mha
  itkImageFileWriterPastingTest1
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterPastingTest1_01.mha)
itk_add_test(
  NAME
  itkImageFileWriterPastingTest2_5
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterPastingTest2
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterPastingTest2_5.mha)
itk_add_test(
  NAME
  itkImageFileWriterPastingTest2_6
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterPastingTest2_6.mha
  itkImageFileWriterPastingTest2
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterPastingTest2_6.mha
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha})
itk_add_test(
  NAME
  itkImageFileWriterPastingTest2_7
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterPastingTest2
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterPastingTest2_7.mha
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolumeCompressed.mha})
itk_add_test(
  NAME
  itkImageFileWriterPastingTest3
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterPastingTest3
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterPastingTest3_01.mha)
itk_add_test(
  NAME
  itkImageFileWriterStreamingPastingCompressingTest_MHA
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterStreamingPastingCompressingTest1
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreamingPastingCompressingTest
  mha
  0
  0
  0
  1
  0
  0
  0
  1)
itk_add_test(
  NAME
  itkImageFileWriterStreamingPastingCompressingTest_NRRD
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterStreamingPastingCompressingTest1
  DATA{${ITK_DATA_ROOT}/Input/vol-ascii.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreamingPastingCompressingTest
  nrrd
  0
  0
  1
  1
  0
  0
  1
  1)
itk_add_test(
  NAME
  itkImageFileWriterStreamingPastingCompressingTest_NHDR
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterStreamingPastingCompressingTest1
  DATA{${ITK_DATA_ROOT}/Input/vol-ascii.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreamingPastingCompressingTest
  nhdr
  0
  0
  1
  1
  0
  0
  1
  1)
itk_add_test(
  NAME
  itkImageFileWriterStreamingPastingCompressingTest_VTK
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreamingPastingCompressingTest000.vtk
  itkImageFileWriterStreamingPastingCompressingTest1
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreamingPastingCompressingTest
  vtk
  0
  0
  0
  0
  0
  0
  0
  0)

# JIRA ITK182
# This test has been disabled due to the above bug. It should be
# enabled when it is resolved and to confirm the above test is
# working.
#
#itk_add_test(NAME itkImageFileWriterStreamingPastingCompressingTest_DCM
#      COMMAND ITKIOImageBaseTestDriver itkImageFileWriterStreamingPastingCompressingTest1
#              DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw} ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreamingPastingCompressingTest dcm 0 0 1 1 0 0 1 1)
itk_add_test(
  NAME
  itkImageFileWriterStreamingTest1_1
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreaming1_1.mha
  itkImageFileWriterStreamingTest1
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreaming1_1.mha)
itk_add_test(
  NAME
  itkImageFileWriterStreamingTest1_2
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreaming1_2.mha
  itkImageFileWriterStreamingTest1
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreaming1_2.mha
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolumeCompressed.mha}
  0)
itk_add_test(
  NAME
  itkImageFileWriterStreamingTest1_3
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreaming1_3.mha
  itkImageFileWriterStreamingTest1
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreaming1_3.mha
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha}
  1)
itk_add_test(
  NAME
  itkImageFileWriterStreamingTest2_4
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreaming2_4.mha
  itkImageFileWriterStreamingTest2
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterStreaming2_4.mha)
itk_add_test(
  NAME
  itkImageFileWriterTest2_1
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterTest2
  ${ITK_TEST_OUTPUT_DIR}/test.nrrd)
itk_add_test(
  NAME
  itkImageFileWriterTest2_2
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterTest2
  ${ITK_TEST_OUTPUT_DIR}/test.mha)
itk_add_test(
  NAME
  itkImageFileWriterTest2_3
  COMMAND
  ITKIOImageBaseTestDriver
  itkImageFileWriterTest2
  ${ITK_TEST_OUTPUT_DIR}/test.vtk)
itk_add_test(
  NAME
  itkImageFileWriterUpdateLargestPossibleRegionTest
  COMMAND
  ITKIOImageBaseTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterUpdateLargestPossibleRegionTest.png
  itkImageFileWriterUpdateLargestPossibleRegionTest
  DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
  ${ITK_TEST_OUTPUT_DIR}/itkImageFileWriterUpdateLargestPossibleRegionTest.png)
itk_add_test(
  NAME
  itkImageIOBaseTest
  COMMAND
  ITKIOImageBaseTestDriver

=== Modules/Registration/RegistrationMethodsv4/test/CMakeLists.txt ===
itk_module_test()
set(ITKRegistrationMethodsv4Tests
    itkImageRegistrationSamplingTest.cxx
    itkSimpleImageRegistrationTest.cxx
    itkSimpleImageRegistrationTest2.cxx
    itkSimpleImageRegistrationTest3.cxx
    itkSimpleImageRegistrationTest4.cxx
    itkSimpleImageRegistrationTestWithMaskAndSampling.cxx
    itkSimplePointSetRegistrationTest.cxx
    itkExponentialImageRegistrationTest.cxx
    itkBSplineExponentialImageRegistrationTest.cxx
    itkTimeVaryingBSplineVelocityFieldImageRegistrationTest.cxx
    itkTimeVaryingVelocityFieldImageRegistrationTest.cxx
    itkSyNImageRegistrationTest.cxx
    itkSyNPointSetRegistrationTest.cxx
    itkBSplineSyNImageRegistrationTest.cxx
    itkBSplineSyNPointSetRegistrationTest.cxx
    itkTimeVaryingBSplineVelocityFieldPointSetRegistrationTest.cxx
    itkQuasiNewtonOptimizerv4RegistrationTest.cxx
    itkBSplineImageRegistrationTest.cxx)

set(INPUTDATA ${ITK_DATA_ROOT}/Input)
set(BASELINE_ROOT ${ITK_DATA_ROOT}/Baseline)
set(TEMP ${ITK_TEST_OUTPUT_DIR})

createtestdriver(ITKRegistrationMethodsv4 "${ITKRegistrationMethodsv4-Test_LIBRARIES}"
                 "${ITKRegistrationMethodsv4Tests}")

itk_add_test(
  NAME
  itkImageRegistrationSamplingTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  itkImageRegistrationSamplingTest)

itk_add_test(
  NAME
  itkSimpleImageRegistrationTestDouble
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  --compareIntensityTolerance
  3.0
  --compareNumberOfPixelsTolerance
  8
  --compare
  DATA{Baseline/itkSimpleImageRegistrationTest.nii,:}
  ${TEMP}/itkSimpleImageRegistrationTestDouble.nii
  itkSimpleImageRegistrationTest
  double
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkSimpleImageRegistrationTestDouble.nii
  100 # number of affine iterations
  10 # number of deformable iterations
)
set_property(
  TEST itkSimpleImageRegistrationTestDouble
  APPEND
  PROPERTY LABELS RUNS_LONG)
set_tests_properties(itkSimpleImageRegistrationTestDouble PROPERTIES COST 30)

itk_add_test(
  NAME
  itkSimpleImageRegistrationTestFloat
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  --compareIntensityTolerance
  3.0
  --compareNumberOfPixelsTolerance
  8
  --compare
  DATA{Baseline/itkSimpleImageRegistrationTest.nii,:}
  ${TEMP}/itkSimpleImageRegistrationTestFloat.nii
  itkSimpleImageRegistrationTest
  float
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkSimpleImageRegistrationTestFloat.nii
  100 # number of affine iterations
  10 # number of deformable iterations
)
set_property(
  TEST itkSimpleImageRegistrationTestFloat
  APPEND
  PROPERTY LABELS RUNS_LONG)
set_tests_properties(itkSimpleImageRegistrationTestFloat PROPERTIES COST 30)

itk_add_test(
  NAME
  itkSimpleImageRegistrationTestWithMaskAndSamplingDouble
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  itkSimpleImageRegistrationTestWithMaskAndSampling
  double
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkSimpleImageRegistrationTestWithMaskAndSamplingDouble.nii.gz
  100 # number of affine iterations
  10 # number of deformable iterations
)
set_property(
  TEST itkSimpleImageRegistrationTestWithMaskAndSamplingDouble
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkSimpleImageRegistrationTestWithMaskAndSamplingFloat
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  itkSimpleImageRegistrationTestWithMaskAndSampling
  float
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkSimpleImageRegistrationTestWithMaskAndSamplingFloat.nii.gz
  100 # number of affine iterations
  10 # number of deformable iterations
)
set_property(
  TEST itkSimpleImageRegistrationTestWithMaskAndSamplingFloat
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkSimpleImageRegistrationTest2
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  itkSimpleImageRegistrationTest2
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkSimpleImageRegistrationTest2New.nii.gz
  100 # number of affine iterations
)
set_property(
  TEST itkSimpleImageRegistrationTest2
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkSimpleImageRegistrationTest3
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  itkSimpleImageRegistrationTest3
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkSimpleImageRegistrationTest3New.nii.gz)
set_property(
  TEST itkSimpleImageRegistrationTest3
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkSimpleImageRegistrationTest4
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  itkSimpleImageRegistrationTest4
  2 # number of dimensions
  DATA{Input/Blob1.mha}
  DATA{Input/Blob2.mha})

itk_add_test(
  NAME
  itkSimplePointSetRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  itkSimplePointSetRegistrationTest)
set_property(
  TEST itkSimplePointSetRegistrationTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkSyNPointSetRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  itkSyNPointSetRegistrationTest)
set_property(
  TEST itkSyNPointSetRegistrationTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkBSplineSyNPointSetRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  itkBSplineSyNPointSetRegistrationTest)
set_property(
  TEST itkBSplineSyNPointSetRegistrationTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkTimeVaryingBSplineVelocityFieldPointSetRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  itkTimeVaryingBSplineVelocityFieldPointSetRegistrationTest)
set_property(
  TEST itkTimeVaryingBSplineVelocityFieldPointSetRegistrationTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkExponentialImageRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  --compareIntensityTolerance
  3.0
  --compareNumberOfPixelsTolerance
  4
  #       --compare DATA{Baseline/itkSimpleImageRegistrationTestNew.nii.gz}
  #                 ${TEMP}/itkExponentialImageRegistrationTestNew.nii.gz
  itkExponentialImageRegistrationTest
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkExponentialImageRegistrationTestNew.nii.gz
  100 # number of affine iterations
  10 # number of deformable iterations
  1
  0.0
  1.0
  10)
set_property(
  TEST itkExponentialImageRegistrationTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkBSplineExponentialImageRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  --compareIntensityTolerance
  3.0
  --compareNumberOfPixelsTolerance
  4
  #       --compare DATA{Baseline/itkSimpleImageRegistrationTestNew.nii.gz}
  #                 ${TEMP}/itkBSplineExponentialImageRegistrationTestNew.nii.gz
  itkBSplineExponentialImageRegistrationTest
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkBSplineExponentialImageRegistrationTestNew.nii.gz
  100 # number of affine iterations
  10 # number of deformable iterations
)
set_property(
  TEST itkBSplineExponentialImageRegistrationTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkTimeVaryingVelocityFieldImageRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  itkTimeVaryingVelocityFieldImageRegistrationTest
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkTimeVaryingVelocityFieldImageRegistrationTest
  2 # number of optimization iterations of the affine transform
  1 # number of iterations for first level of the displacement field
  1 # number of iterations for second level of the displacement field
  1 # number of iterations for third level of the displacement field
  0.5 # learning rate
)
set_property(
  TEST itkTimeVaryingVelocityFieldImageRegistrationTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkTimeVaryingBSplineVelocityFieldImageRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  itkTimeVaryingBSplineVelocityFieldImageRegistrationTest
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkTimeVaryingBSplineVelocityFieldImageRegistrationTest
  2 # number of optimization iterations of the affine transform
  1 # number of iterations for first level of the displacement field
  1 # number of iterations for second level of the displacement field
  1 # number of iterations for third level of the displacement field
  0.5 # learning rate
  1.0e-7
  10)

set_property(
  TEST itkTimeVaryingBSplineVelocityFieldImageRegistrationTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  itkSyNImageRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  itkSyNImageRegistrationTest
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkSyNImageRegistrationTest
  10 # number of optimization iterations of the displacement field
  0.5 # learning rate
)

itk_add_test(
  NAME
  itkBSplineSyNImageRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  itkBSplineSyNImageRegistrationTest
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkBSplineSyNImageRegistrationTest
  10 # number of optimization iterations of the displacement field
  0.5 # learning rate
)

itk_add_test(
  NAME
  itkQuasiNewtonOptimizerv4RegistrationTest1
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  itkQuasiNewtonOptimizerv4RegistrationTest
  2 # number of dimensions
  ms # MeanSquares metric
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkQuasiNewtonOptimizerv4RegistrationTest1.nii.gz
  5
  2)

itk_add_test(
  NAME
  itkQuasiNewtonOptimizerv4RegistrationTest2
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  itkQuasiNewtonOptimizerv4RegistrationTest
  2 # number of dimensions
  mi # metric of joint histogram mutual information
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkQuasiNewtonOptimizerv4RegistrationTest2.nii.gz
  5
  2)

itk_add_test(
  NAME
  itkQuasiNewtonOptimizerv4RegistrationTest3
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  itkQuasiNewtonOptimizerv4RegistrationTest
  2 # number of dimensions
  anc # metric of ants neighborhood correlation
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkQuasiNewtonOptimizerv4RegistrationTest3.nii.gz
  5
  2)

itk_add_test(
  NAME
  itkBSplineImageRegistrationTest
  COMMAND
  ITKRegistrationMethodsv4TestDriver
  --with-threads
  1
  --compareIntensityTolerance
  3.0
  --compareNumberOfPixelsTolerance
  4
  #       --compare DATA{Baseline/itkSimpleImageRegistrationTestNew.nii.gz}
  #                 ${TEMP}/itkBSplineImageRegistrationTestNew.nii.gz
  itkBSplineImageRegistrationTest
  2 # number of dimensions
  DATA{Input/r16slice_rigid.nii.gz}
  DATA{Input/r64slice.nii.gz}
  ${TEMP}/itkBSplineImageRegistrationTestNew.nii.gz
  100 # number of affine iterations
  10 # number of deformable iterations
)
set_property(
  TEST itkBSplineImageRegistrationTest
  APPEND
  PROPERTY LABELS RUNS_LONG)
set_property(
  TEST itkBSplineImageRegistrationTest
  APPEND
  PROPERTY RUN_SERIAL True)
set_tests_properties(itkBSplineImageRegistrationTest PROPERTIES COST 30)

=== Modules/Core/Common/wrapping/test/CMakeLists.txt ===
# This test doesn't compile.  It exercises the bug I ran into if you multiply 2 vector images; if you
# try to compile it the compile fails.
# itk_add_test(NAME itkVectorMultiplyTest COMMAND ITKCommon2TestDriver itkVectorMultiplyTest)
if(ITK_WRAP_PYTHON)
  itk_python_add_test(
    NAME
    itkMetaDataDictionaryPythonTest
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/itkMetaDataDictionaryTest.py)
  itk_python_add_test(
    NAME
    itkDirectoryPythonTest
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/itkDirectoryTest.py)
  itk_python_expression_add_test(
    NAME
    itkObjectPythonTest
    EXPRESSION
    "itkObject = itk.Object.New()")
  itk_python_add_test(
    NAME
    itkIndexOffsetPythonTest
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/itkIndexOffsetTest.py)
  itk_python_add_test(
    NAME
    itkImageDuplicatorPythonTest
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/itkImageDuplicatorTest.py)
  itk_python_add_test(
    NAME
    itkImagePythonTest
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/itkImageTest.py)
  itk_python_add_test(
    NAME
    itkMatrixPythonTest
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/itkMatrixTest.py)
  itk_python_add_test(
    NAME
    itkVariableLengthVectorPythonTest
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/itkVariableLengthVectorTest.py)
  itk_python_add_test(
    NAME
    itkPointSetSerializationTest
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/itkPointSetSerializationTest.py)
  itk_python_add_test(
    NAME
    itkSpatialOrientationAdapterTest
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/itkSpatialOrientationAdapterTest.py)
endif()

=== Modules/ThirdParty/DoubleConversion/src/double-conversion/CMakeLists.txt ===
if("${DOUBLE_CONVERSION_CORRECT_DOUBLE_OPERATIONS}" MATCHES "^${DOUBLE_CONVERSION_CORRECT_DOUBLE_OPERATION}$")
  set(_test_source "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/double-correction-needed.cc")
  file(WRITE ${_test_source} "
  #include <stdio.h>
  int main(int, char **)
  {
    const double correct = 89255.0/1e22;
    printf(\"89255.0/1e22 = %g\", correct);
    if( correct != 89255e-22 )
      {
      // correction required
      return 0;
      }
    return 1;
  }")
  try_run(DOUBLE_CONVERSION_CORRECT_DOUBLE_OPERATIONS DOUBLE_CORRECT_NEEDED_COMPILED
    ${CMAKE_CURRENT_BINARY_DIR} ${_test_source}
    RUN_OUTPUT_VARIABLE _double_correction_out)
  message(STATUS "Double correction test returned: ${_double_correction_out}")
endif()
configure_file(double-conversion-configure.h.in double-conversion-configure.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(headers
  bignum-dtoa.h
  bignum.h
  cached-powers.h
  diy-fp.h
  double-conversion.h
  double-to-string.h
  fast-dtoa.h
  fixed-dtoa.h
  ieee.h
  string-to-double.h
  strtod.h
  utils.h
  ${CMAKE_CURRENT_BINARY_DIR}/double-conversion-configure.h
)


add_library(itkdouble-conversion
  bignum.cc
  bignum-dtoa.cc
  cached-powers.cc
  double-to-string.cc
  fast-dtoa.cc
  fixed-dtoa.cc
  string-to-double.cc
  strtod.cc
  ${headers}
)

if(ITK_LIBRARY_PROPERTIES)
  set_target_properties(itkdouble-conversion PROPERTIES ${ITK_LIBRARY_PROPERTIES})
endif()

itk_module_target(itkdouble-conversion NO_INSTALL)

#
# install command to set up library install
# given the above PUBLIC_HEADER property set, this
# pulls along all the header files with the library.
install(TARGETS itkdouble-conversion
  EXPORT ${ITKDoubleConversion-targets}
  RUNTIME DESTINATION "${ITKDoubleConversion_INSTALL_RUNTIME_DIR}" COMPONENT Applications
  LIBRARY DESTINATION "${ITKDoubleConversion_INSTALL_LIBRARY_DIR}" COMPONENT Libraries
  ARCHIVE DESTINATION "${ITKDoubleConversion_INSTALL_LIBRARY_DIR}" COMPONENT Development)

install(FILES ${headers}
  DESTINATION "${ITKDoubleConversion_INSTALL_INCLUDE_DIR}" COMPONENT Development)

=== Modules/ThirdParty/MetaIO/src/MetaIO/src/tests/CMakeLists.txt ===
if (NOT ITK_TEST_OUTPUT_DIR) # we are not part of ITK source tree
  set(ITK_TEST_OUTPUT_DIR ${CMAKE_BINARY_DIR}/Testing/Temporary/)
  if(NOT EXISTS ${ITK_TEST_OUTPUT_DIR})
    file(MAKE_DIRECTORY ${ITK_TEST_OUTPUT_DIR})
    message(STATUS "Created temporary test folder:\n  ${ITK_TEST_OUTPUT_DIR}")
  endif()
endif()

function(MetaAddTest ExeName)
  add_executable( ${ExeName} ${ExeName}.cxx )
  target_link_libraries( ${ExeName} ${METAIO_NAMESPACE} ${ZLIB_LIBRARIES})
  add_test(NAME ${ExeName}
           COMMAND ${ExeName}
           WORKING_DIRECTORY ${ITK_TEST_OUTPUT_DIR})
endfunction()

MetaAddTest(testMeta1Utils)
MetaAddTest(testMeta2Object)
MetaAddTest(testMeta3Image)
MetaAddTest(testMeta4Tube)
MetaAddTest(testMeta5Blob)
MetaAddTest(testMeta6Surface)
MetaAddTest(testMeta7Line)
MetaAddTest(testMeta8Scene)
MetaAddTest(testMeta9Landmark)
MetaAddTest(testMeta10Contour)
MetaAddTest(testMeta11Form)
MetaAddTest(testMeta12Array)

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>

_realname=itk
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=5.4.0
pkgrel=2
pkgdesc='An open-source C++ toolkit for medical image processing (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url='https://www.itk.org/'
msys2_repository_url="https://github.com/InsightSoftwareConsortium/ITK"
msys2_references=(
  'aur: itk'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-dcmtk"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gdcm"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         #"${MINGW_PACKAGE_PREFIX}-opencl-icd"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-gtest"
             "${MINGW_PACKAGE_PREFIX}-opencv"
             "${MINGW_PACKAGE_PREFIX}-vtk"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
optdepends=("${MINGW_PACKAGE_PREFIX}-opencv: ITK-OpenCV bridge"
            "${MINGW_PACKAGE_PREFIX}-vtk: ITK-VTK bridge")
source=("https://github.com/InsightSoftwareConsortium/ITK/archive/v${pkgver}/ITK-${pkgver}.tar.gz")
sha256sums=('d71a36fc0aee2c9257fe128f7657feb1e671461bd48561b620619f290c71795e')

prepare() {
  cd "${srcdir}"/ITK-${pkgver}
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  local -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_DOCUMENTATION=OFF \
    -DBUILD_EXAMPLES=OFF \
    -DBUILD_TESTING=OFF \
    -DITK_INSTALL_INCLUDE_DIR=include/ITK \
    -DITK_INSTALL_DATA_DIR=share/ITK \
    -DITK_INSTALL_DOC_DIR=share/doc/ITK \
    -DITK_INSTALL_PACKAGE_DIR=lib/cmake/ITK \
    -DITK_CUSTOM_LIBRARY_SUFFIX="" \
    -DITK_LEGACY_REMOVE=ON \
    -DITK_FUTURE_LEGACY_REMOVE=ON \
    -DITK_BUILD_DEFAULT_MODULES=OFF \
    -DITKGroup_Core=ON \
    -DITKGroup_IO=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \
    -DITKGroup_Filtering=ON \
    -DITKGroup_Registration=ON \
    -DITKGroup_Segmentation=ON \
    -DITKGroup_Numerics=ON \
    -DITKGroup_Video=ON \
    -DITKGroup_ThirdParty=ON \
    -DITKGroup_Bridge=ON \
    -DITKGroup_Nonunit=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \ \
    -DITKGroup_Compatibility=ON \
    -DModule_ITKVideoBridgeOpenCV=ON \
    -DModule_ITKVtkGlue=ON \
    -DITK_USE_GPU=OFF \
    -DUSE_FFTWD=ON \
    -DUSE_FFTWF=ON \
    -DITK_USE_SYSTEM_LIBRARIES=ON \
    -DITK_USE_SYSTEM_DCMTK=ON \
    -DITK_USE_SYSTEM_DOUBLECONVERSION=ON \
    -DITK_USE_SYSTEM_EIGEN=ON \
    -DITK_USE_SYSTEM_EXPAT=ON \
    -DITK_USE_SYSTEM_FFTW=ON \
    -DITK_USE_SYSTEM_GDCM=ON \
    -DITK_USE_SYSTEM_GOOGLETEST=ON \
    -DITK_USE_SYSTEM_HDF5=ON \
    -DITK_USE_SYSTEM_JPEG=ON \
    -DITK_USE_SYSTEM_MINC=OFF \
    -DITK_USE_SYSTEM_PNG=ON \
    -DITK_USE_SYSTEM_TIFF=ON \
    -DITK_USE_SYSTEM_VXL=OFF \
    -DITK_USE_SYSTEM_ZLIB=ON \
    -DITK_SKIP_PATH_LENGTH_CHECKS=1 \
    -DITK_FORBID_DOWNLOADS=ON \
    -DVNL_CONFIG_THREAD_SAFE=ON \
    -DVNL_CONFIG_ENABLE_SSE2_ROUNDING=ON \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    "${_extra_config[@]}" \
    "../ITK-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  cd "${pkgdir}${MINGW_PREFIX}"
  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|\${_IMPORT_PREFIX}|g" \
    -i "lib/cmake/${_realname}/ITKTargets-release.cmake"
  find "lib/cmake/${_realname}" -name '*.cmake' -exec \
    sed -s "s|${PREFIX_DEPS}|\${ITK_INSTALL_PREFIX}|g" -i {} \;

  install -Dm644 "${srcdir}/ITK-${pkgver}/LICENSE" "share/licenses/${_realname}/LICENSE"
  install -Dm644 "${srcdir}/ITK-${pkgver}/NOTICE" "share/licenses/${_realname}/NOTICE"
  install -Dm644 "${srcdir}/ITK-${pkgver}/Modules/ThirdParty/KWSys/src/KWSys/Copyright.txt" \
    "share/licenses/${_realname}/KWSys/Copyright.txt"
}
